import { pbkdf2Sync, randomBytes, timingSafeEqual } from 'crypto';
export const hashPassword = (password: string) => {
  const salt = randomBytes(16).toString('hex');
  const hash = pbkdf2Sync(password, salt, 1000, 128, 'sha512').toString('hex');
  const hashedPassword = `${salt}:${hash}`;
  return hashedPassword;
};

export const verifyPassword = (password: string, hashedPassword: string) => {
  const [salt, hash] = hashedPassword.split(':') as [string, string];
  const hashBuffer = Buffer.from(hash, 'hex');
  const result = pbkdf2Sync(password, salt, 1000, 128, 'sha512');
  return timingSafeEqual(hashBuffer, result);
};
